package org.xdoclet.plugin.beaninfo.qtags;

public class JavabeanIconsTagImpl extends org.xdoclet.XDocletTag implements org.xdoclet.plugin.beaninfo.qtags.JavabeanIconsTag {
    public static final String NAME = "javabean.icons";
    private static final java.util.List ALLOWED_PARAMETERS = java.util.Arrays.asList( new String[] {
		"mono16",
		"color16",
		"mono32",
		"color32",
    	""
    });
    
    private static final java.util.List ALLOWED_VALUES = java.util.Arrays.asList( new String[] {
        ""
    });
    public JavabeanIconsTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber, org.xdoclet.QDoxPropertyExpander expander) {
        super(name, value, entity, lineNumber, expander);
    }
    public JavabeanIconsTagImpl(String name, String value, com.thoughtworks.qdox.model.AbstractJavaEntity entity, int lineNumber) {
        super(name, value, entity, lineNumber);
    }

    public java.lang.String getMono16() {
		boolean required = false;
        String result = getNamedParameter("mono16");
        if(required && result == null) {
            bomb("mono16=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getColor16() {
		boolean required = false;
        String result = getNamedParameter("color16");
        if(required && result == null) {
            bomb("color16=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getMono32() {
		boolean required = false;
        String result = getNamedParameter("mono32");
        if(required && result == null) {
            bomb("mono32=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }
    public java.lang.String getColor32() {
		boolean required = false;
        String result = getNamedParameter("color32");
        if(required && result == null) {
            bomb("color32=\"???\" must be specified.");
        }

		java.lang.String retVal = null;


		if (result != null) {
	            retVal = result;
		}
		
		return retVal;
    }

    protected void validateLocation() {
        
        // check uniqueness

        // warn deprecation
        
        // check for allowed values for whole tag
        if( ALLOWED_VALUES.size() > 1 && !ALLOWED_VALUES.contains(getValue())) {
            bomb( "\"" + getValue() +"\" is not a valid value. Allowed values are ");
        }        
        // Verify that all parameters are known.
        final java.util.Collection parameterNames = getNamedParameterMap().keySet();
        for (java.util.Iterator iterator = parameterNames.iterator(); iterator.hasNext();) {
            String parameterName = (String) iterator.next();
            if (!ALLOWED_PARAMETERS.contains(parameterName)) {
                bomb(parameterName + " is an invalid parameter name.");
            }
        }
        
        // Get all the parameters to validate their contents
        getMono16();
        getColor16();
        getMono32();
        getColor32();
    }

    public void validateModel() {
        // check uniqueness
    }
}